Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.awt
Class FocusTraversalPolicy

    java.lang.Object
      java.awt.FocusTraversalPolicy

Direct Known Subclasses:
  ContainerOrderFocusTraversalPolicy, InternalFrameFocusTraversalPolicy

public abstract class FocusTraversalPolicy
extends Object

A FocusTraversalPolicy defines the order in which Components with a particular focus cycle root are traversed. Instances can apply the policy to arbitrary focus cycle roots, allowing themselves to be shared across Containers. They do not need to be reinitialized when the focus cycle roots of a Component hierarchy change.

The core responsibility of a FocusTraversalPolicy is to provide algorithms determining the next and previous Components to focus when traversing forward or backward in a UI. Each FocusTraversalPolicy must also provide algorithms for determining the first, last, and default Components in a traversal cycle. First and last Components are used when normal forward and backward traversal, respectively, wraps. The default Component is the first to receive focus when traversing down into a new focus traversal cycle. A FocusTraversalPolicy can optionally provide an algorithm for determining a Window's initial Component. The initial Component is the first to receive focus when a Window is first made visible.

Since:
  1.4
See Also:
  `Container.setFocusTraversalPolicy(java.awt.FocusTraversalPolicy)`, `Container.getFocusTraversalPolicy()`, `KeyboardFocusManager.setDefaultFocusTraversalPolicy(java.awt.FocusTraversalPolicy)`, `KeyboardFocusManager.getDefaultFocusTraversalPolicy()`

Constructor Summary
`FocusTraversalPolicy()`

Method Summary
`abstract Component` | `getComponentAfter(Container focusCycleRoot, Component aComponent)` Returns the Component that should receive the focus after aComponent.
`abstract Component` | `getComponentBefore(Container focusCycleRoot, Component aComponent)` Returns the Component that should receive the focus before aComponent.
`abstract Component` | `getDefaultComponent(Container focusCycleRoot)` Returns the default Component to focus.
`abstract Component` | `getFirstComponent(Container focusCycleRoot)` Returns the first Component in the traversal cycle.
`Component` | `getInitialComponent(Window window)` Returns the Component that should receive the focus when a Window is made visible for the first time.
`abstract Component` | `getLastComponent(Container focusCycleRoot)` Returns the last Component in the traversal cycle.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### FocusTraversalPolicy

    public FocusTraversalPolicy()

Method Detail

### getComponentAfter

    public abstract Component getComponentAfter(Container focusCycleRoot,
                                                Component aComponent)

  Returns the Component that should receive the focus after aComponent. focusCycleRoot must be a focus cycle root of aComponent.

  Parameters:
    `focusCycleRoot` - a focus cycle root of aComponent
    `aComponent` - a (possibly indirect) child of focusCycleRoot, or focusCycleRoot itself
  Returns:
    the Component that should receive the focus after aComponent, or null if no suitable Component can be found
  Throws:
    `IllegalArgumentException` - if focusCycleRoot is not a focus cycle root of aComponent, or if either focusCycleRoot or aComponent is null

### getComponentBefore

    public abstract Component getComponentBefore(Container focusCycleRoot,
                                                 Component aComponent)

  Returns the Component that should receive the focus before aComponent. focusCycleRoot must be a focus cycle root of aComponent.

  Parameters:
    `focusCycleRoot` - a focus cycle root of aComponent
    `aComponent` - a (possibly indirect) child of focusCycleRoot, or focusCycleRoot itself
  Returns:
    the Component that should receive the focus before aComponent, or null if no suitable Component can be found
  Throws:
    `IllegalArgumentException` - if focusCycleRoot is not a focus cycle root of aComponent, or if either focusCycleRoot or aComponent is null

### getFirstComponent

    public abstract Component getFirstComponent(Container focusCycleRoot)

  Returns the first Component in the traversal cycle. This method is used to determine the next Component to focus when traversal wraps in the forward direction.

  Parameters:
    `focusCycleRoot` - the focus cycle root whose first Component is to be returned
  Returns:
    the first Component in the traversal cycle when focusCycleRoot is the focus cycle root, or null if no suitable Component can be found
  Throws:
    `IllegalArgumentException` - if focusCycleRoot is null

### getLastComponent

    public abstract Component getLastComponent(Container focusCycleRoot)

  Returns the last Component in the traversal cycle. This method is used to determine the next Component to focus when traversal wraps in the reverse direction.

  Parameters:
    `focusCycleRoot` - the focus cycle root whose last Component is to be returned
  Returns:
    the last Component in the traversal cycle when focusCycleRoot is the focus cycle root, or null if no suitable Component can be found
  Throws:
    `IllegalArgumentException` - if focusCycleRoot is null

### getDefaultComponent

    public abstract Component getDefaultComponent(Container focusCycleRoot)

  Returns the default Component to focus. This Component will be the first to receive focus when traversing down into a new focus traversal cycle rooted at focusCycleRoot.

  Parameters:
    `focusCycleRoot` - the focus cycle root whose default Component is to be returned
  Returns:
    the default Component in the traversal cycle when focusCycleRoot is the focus cycle root, or null if no suitable Component can be found
  Throws:
    `IllegalArgumentException` - if focusCycleRoot is null

### getInitialComponent

    public Component getInitialComponent(Window window)

  Returns the Component that should receive the focus when a Window is made visible for the first time. Once the Window has been made visible by a call to `show()` or `setVisible(true)`, the initial Component will not be used again. Instead, if the Window loses and subsequently regains focus, or is made invisible or undisplayable and subsequently made visible and displayable, the Window's most recently focused Component will become the focus owner. The default implementation of this method returns the default Component.

  Parameters:
    `window` - the Window whose initial Component is to be returned
  Returns:
    the Component that should receive the focus when window is made visible for the first time, or null if no suitable Component can be found
  Throws:
    `IllegalArgumentException` - if window is null
  See Also:
    `getDefaultComponent(java.awt.Container)`, `Window.getMostRecentFocusOwner()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2003 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.